# 00functions.sh
# Right now just appath() which appends
# any number  of path component only if it is missing
# from the path like variable
# you can add a component `:' (for TeX variables this is 
# useful), but not `component:'.  The `:' is just simply removed.

app_one () {
pathlikevar=$1
pathcomponent=$2
oldumask=$(umask)
oldvalue=$(eval echo \$$pathlikevar)

TEMP_NAME=$(mktemp /tmp/00functions.XXXXXX) || return 1
trap "rm -f $TEMP_NAME* 2>/dev/null" 0
case $pathcomponent in
    "/")
	echo 'pathcomponent cannot be "/"'
	;;
     ":")
	export $pathlikevar=$oldvalue:
	;;
     "")
     	echo 'pathcomponent cannot be ""'
	;;
     *)
	pathcomponent=$(echo $pathcomponent| sed 's/://g')
	if [ "$pathcomponent" = "" ]; then
	    echo 'pathcomponent cannot be only 2 or more ":"'
	else
	    case $oldvalue in
		"")
		    export $pathlikevar=$pathcomponent
		    ;;
		*)
		    umask 007
		    function check_endline() { 
			echo "$pathcomponent\$" > $TEMP_NAME.endline
			echo $oldvalue | grep -f $TEMP_NAME.endline
		    }
		    function check_colon() {
			echo "$pathcomponent:" > $TEMP_NAME.colon
			echo $oldvalue | grep -f $TEMP_NAME.colon
		    }
		if [ "$(check_endline)" = "" ] && [ "$(check_colon)" = "" ]; then
		    export $pathlikevar=$oldvalue:$pathcomponent
		fi
		umask $oldumask
		if [ "$?" = 0 ]; then
		    rm -f $TEMP_NAME*
		fi
		;;
	    esac	    
	    fi
esac	
}

function appath() {
    if [ "$#" -eq 0 ]; then
	echo "Usage: pathlikevar pathcomponent1 [pathcomponent2 ...]"
	return 1
    fi
    pathlikevar=$1
    shift
    for j in $@; do
	if ! app_one $pathlikevar $j; then
	    continue
	fi
    done
}

